#include "pointer.h"



int get_physical( long segment, unsigned offset , unsigned *physical ){
	struct segment_t *seg;
	unsigned limit, base;

	seg = (struct segment_t *)segment;
	if(!seg->valid) return(0);

	limit = (seg->descriptor[0] & 0xffff) + (seg->descriptor[1] & 0xf0000);
	if((seg->descriptor[1] & 0x400000) != 0) limit = limit << 12;

	base = (seg->descriptor[0] >> 16) + ((seg->descriptor[1] & 0xff) << 16);
	base += seg->descriptor[1] & 0xff000000;

	*physical = base + offset;

	if((base + offset) > (base + limit)) return(0);
	return(1);
}
