#include "structures.h"

void word_read (FILE * const file, register char * str, const size_t len)
{
	register int inputChar;
	register char * end;

        do
        {
          inputChar = fgetc (file);
        }
        while (inputChar != EOF && isspace (inputChar) != 0);
	for (end = str + len - 1;
	     str < end && inputChar != EOF && isspace (inputChar) == 0;
	     ++str, inputChar = fgetc (file))
	   *str = inputChar;
	*str = '\0';
	while (inputChar != EOF && isspace (inputChar) == 0)
	  inputChar = fgetc (file);
	(void) ungetc (inputChar, file);
}

void config_read (FILE * const file)
{
     register int inputChar;
     char typeChar;
     struct mem_struct * tmp, input;

     memlist    = NULL;
     nr_strucs  = 0;

     for (;;)
     {
	do
	{
             inputChar = fgetc (file);
	} 
	while (inputChar != EOF && inputChar != '{');
	if (inputChar == EOF)
          return;
	if (fscanf (file, " %c", & typeChar) != 1)
	  return;
	inputChar = typeChar;
	if (typeChar == 'H' || typeChar == 'h')
	{
		while (inputChar != EOF && isspace (inputChar) == 0)
		  inputChar = fgetc (file);
		if (fscanf (file, " %i", & history_length) != 1)
		  return;
		continue;
	}

	if (typeChar == 'S' || typeChar == 's')
        {
          inputChar = fgetc (file);
          if (inputChar == 'T' || inputChar == 't')
          {
	      inputChar = fgetc (file);
	      if (inputChar == 'A' || inputChar == 'a')
	      {
                while (inputChar != EOF && isspace (inputChar) == 0)
                  inputChar = fgetc (file);
                if (fscanf (file, " %i %i", & stack_above, & stack_below) != 2)
		  return;
	        continue;
	      }
          }
	  input.element_count = 1;
        }
	while (inputChar != EOF && isspace (inputChar) == 0)
	   inputChar = fgetc (file);
	if (inputChar == EOF)
	  return;
	input.name [0] = inputChar;
	word_read (file, input.name + 1, WORD_LEN - 1);
	if (fscanf (file, " %i", & input.base) != 1)
          return;
	if ((typeChar == 'L' || typeChar == 'l') &&
	    fscanf (file, " %i", & input.element_count) != 1)
	  return;
	if (fscanf (file, " %i", & input.value_count) != 1)
	  return;
        if (input.value_count > 0)
	  input.values = (struct value_struct *) malloc (sizeof (struct value_struct) * input.value_count);
	if (input.values == NULL)
	  return;
	{
	   struct value_struct * current, * end;

	   for (current = input.values, end = current + input.value_count;
                current < end;
		++current)
           {
		word_read (file, current->name, WORD_LEN);
		if (fscanf (file, " %i", & current->size) != 1)
		{
	             free (input.values);
		     return;
	        }
	   }
	}
        do
        {
            inputChar = fgetc (file);
        } while (inputChar != EOF && inputChar != '}');
        tmp = (struct mem_struct *) realloc (memlist, sizeof(struct mem_struct) * (++nr_strucs));
        if (tmp == NULL)
        {
          --nr_strucs;
          return;
        }
        memlist = tmp;
        memlist [nr_strucs - 1] = input;
    }
}

